#include <Arduboy2.h>
#include <ArduboyPlaytune.h>

const byte score[] PROGMEM = {
// Happy Birthday
 4,176, 0x90,55, 1,194, 0x90,55, 0,150, 0x90,57, 0x91,48, 2,88, 0x90,55, 0x91,52, 2,88, 0x90,60, 0x91,52,
 2,88, 0x90,59, 0x91,43, 2,88, 0x91,50, 2,88, 0x90,55, 1,194, 0x90,55, 0,150, 0x90,57, 0x91,43, 2,88,
 0x90,55, 0x91,50, 2,88, 0x90,62, 0x91,50, 2,88, 0x90,60, 0x91,48, 2,88, 0x91,52, 2,88, 0x90,55, 0x91,52,
 1,194, 0x90,55, 0,150, 0x90,67, 0x91,48, 2,88, 0x90,64, 0x91,52, 2,88, 0x90,60, 0x91,55, 2,88, 0x90,59,
 0x91,41, 2,88, 0x90,57, 3,132, 0x90,65, 0x91,41, 1,194, 0x90,65, 0,150, 0x90,64, 0x91,48, 2,88, 0x90,60,
 0x91,52, 2,88, 0x90,55, 0x91,62, 0x92,43, 2,88, 0x90,52, 0x91,55, 0x92,60, 0x93,48, 7,8, 0x80, 0x81, 0x82, 0x83,
 0xf0
};

Arduboy2 arduboy;
ArduboyPlaytune tunes(arduboy.audio.enabled);

void setup()
{
  arduboy.begin();

  arduboy.setFrameRate(60);  

  // audio setup
  tunes.initChannel(PIN_SPEAKER_1);
#ifndef AB_DEVKIT
  // if not a DevKit
  tunes.initChannel(PIN_SPEAKER_2);
#else
  // if it's a DevKit
  tunes.initChannel(PIN_SPEAKER_1); // use the same pin for both channels
  tunes.toneMutesScore(true);       // mute the score when a tone is sounding
#endif
}


int x = 20, y = 10; // initial text position

void loop()
{
  // pause render until it's time for the next frame
  if (!(arduboy.nextFrame()))
    return;

  arduboy.clear();
  arduboy.setCursor(x,y);
  arduboy.setTextSize(1);
  arduboy.print("Happy Birthday");
  arduboy.setCursor(x+20, y+20);
  arduboy.setTextSize(3);
  arduboy.print("Lee");
  arduboy.display();

  // play the tune if we aren't already
  if (!tunes.playing())
    tunes.playScore(score);
}
