/*
Hello, World! example
June 11, 2015
Copyright (C) 2015 David Martinez
All rights reserved.
This code is the most basic barebones code for writing a program for Arduboy.

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or (at your option) any later version.
*/

#include <Arduboy2.h>

// make an instance of arduboy used for many functions
Arduboy2 arduboy;


int angle = 0;
float x = 64;
float y = 32;
float spd = 0;
int radius = 5;
bool inverted = false;
long prevMillis;

// This function runs once in your game.
// use it for anything that needs to be set only once in your game.
void setup() {

  randomSeed(analogRead(A3));

  angle = random(0,360);
  spd = random(1,10);
  
  // initiate arduboy instance
  arduboy.begin();

  // here we set the framerate to 15, we do not need to run at
  // default 60 and it saves us battery life
  arduboy.setFrameRate(60);
}

// our main game loop, this runs once every cycle/frame.
// this is where our game logic goes.
void loop() {

  if (millis() > prevMillis+10){
    x = round(x + cos(angle*PI/180)*spd);
    y = round(y + sin(angle*PI/180)*spd);

    if(x-radius < 0 || x+radius > 128){
      angle = 180-angle;  
      }
    
    if (y-radius < 0 || y+radius > 64){
      angle = -angle;
    }  

    angle = angle % 360;
    prevMillis = millis();
  }
  
  // pause render until it's time for the next frame  
  if (!(arduboy.nextFrame()))
    return;

  // first we clear our screen to black
  arduboy.clear();


  if(arduboy.pressed(A_BUTTON)){
    x = 64;
    y = 32;
    angle = random(0,360);
    spd = random(1,10);    
  }
  else if (arduboy.pressed(B_BUTTON)){
    inverted = !inverted;
    arduboy.invert(!inverted);
  }

  arduboy.drawCircle(x,y,radius,WHITE);
  
  // then we finaly we tell the arduboy to display what we just wrote to the display
  arduboy.display();
}
