#ifndef COMMON_H
#define COMMON_H
#ifdef __cplusplus
extern "C" {
#endif

#include <stdarg.h>
#include "debug.h"

//---------------------------------------------------------------------------
typedef unsigned char			u8;
typedef unsigned short			u16;
typedef unsigned long			u32;
typedef signed char				s8;
typedef signed short			s16;
typedef signed long				s32;
typedef volatile u8				vu8;
typedef volatile u16			vu16;
typedef volatile u32			vu32;
typedef volatile s8				vs8;
typedef volatile s16			vs16;
typedef volatile s32			vs32;

#define TRUE					true
#define FALSE					false
#define NUM2FIX(N)				((N) << 7)
#define FIX2NUM(F)				((F) >> 7)
#define ASSERT(x)				if(!(x)) _SystemError("%s(%d)"#x"\n", __FILE__, __LINE__)
#define ERROR(x)				_SystemError("%s(%d)%x\n", #x, __FILE__, __LINE__)
#define TRACEOUT				DebugPrint

//---------------------------------------------------------------------------
void  _Memset(void* s, u8 c, s16 size);
char* _Sprintf(char* buf, const char* fmt, ...);
void  _SprintfDo(char* str, const char* fmt, va_list ap);
char* _SprintfNum(s16 val, s16 base, char* s);
char* _SprintfNumCol(s16 val, s16 base, char* s, s16 col, char colChr, bool isTop);
char* _SprintfHex(u32 val, char* s, char hex);
char* _SprintfHexCol(u32 val, char* s, s16 col, char colChr, bool isTop, char hex);
char* _SprintfStr(char* val, char* s);
bool  _IsDigit(char c);

void  _SystemError(const char* f, ...);


// AXeChp
s16   _MoveFx(s16 fx, s16 fmx);
s16   _MoveFy(s16 fy, s16 fmy);


#ifdef __cplusplus
}
#endif
#endif
