import processing.serial.*;

Serial myPort;
byte[] inBuffer;
color background;
color foreground;
float scale = 4;

void setup(){
  size(1024, 512);   
  printArray(Serial.list());
  myPort = new Serial(this, Serial.list()[1], 9600);
  background = color(0,0,0);
  foreground = color(0,255,0);
  //foreground = color(random(125,255),random(125,255),random(125,255));
  inBuffer = new byte[1024];  
  frameRate(60);
  surface.setResizable(true);
  noStroke();
}

void draw(){
  scale = round(width/128.0);
  while (myPort.available() > 0) {    
    inBuffer = myPort.readBytes();
    myPort.readBytes(inBuffer);
    background(background);
    if (inBuffer != null) {        
        for(int i=0; i< inBuffer.length; i++){          
          if(inBuffer[i] != 0){
            for(int j=0; j<8; j++){
              if((inBuffer[i] >> j & 1 ) == 1){                             
                fill(foreground);
              }
              else{
                fill(background);
              }                             
              rect((i%128)*scale,scale*(j+floor(i/128)*8),scale,scale);
            }
          }
         }                       
    }
  }
}